// 3MacsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "3Macs.h"
#include "3MacsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy3MacsDlg dialog

CMy3MacsDlg::CMy3MacsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy3MacsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy3MacsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy3MacsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy3MacsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy3MacsDlg, CDialog)
	//{{AFX_MSG_MAP(CMy3MacsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnReStart)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy3MacsDlg message handlers

BOOL CMy3MacsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	
	HKEY	key;
	long	res;
	DWORD	stat,size,type;

	if (RegCreateKeyEx(HKEY_CLASSES_ROOT,"3Macs",NULL,"3Macs",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&key,&stat)==ERROR_SUCCESS)
	{         
		if (stat==REG_OPENED_EXISTING_KEY)
		{
			size=sizeof(lastlist);
			res=RegQueryValueEx(key,"lastfile",NULL,&type,(unsigned char*)lastlist,&size);
			if (res!=ERROR_SUCCESS)	
				strcpy(lastlist,"NULL");
			size=sizeof(mode);
			res=RegQueryValueEx(key,"lastmode",NULL,&type,(unsigned char*)&mode,&size);
			if (res!=ERROR_SUCCESS)	
				mode=0;
		}
	}
	if (strlen(AfxGetApp()->m_lpCmdLine)>0)
		strcpy(lastlist,AfxGetApp()->m_lpCmdLine);
	RegCloseKey(key);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_fontLogo.CreateFont(24, 0, 0, 0, FW_BOLD, TRUE, FALSE,0,0,0,0,0,0,"Arial");
	m_LogoText="3Macs Beta 1";
	
	m_dlgPropSheet.AddPage(&m_pageSCC);
	m_pageSCC.SetParent(this);
	m_dlgPropSheet.AddPage(&m_pageCOM);
	m_pageCOM.SetParent(this);
	m_dlgPropSheet.AddPage(&m_pageLog);
	m_pageLog.SetParent(this);
	//m_dlgPropSheet.AddPage(&m_pageCode);
	//m_pageCode.SetParent(this);
	m_dlgPropSheet.AddPage(&m_pageAbout);
	m_pageAbout.SetParent(this);
	//m_dlgPropSheet.AddPage(&m_pageHelp);
	//m_pageCode.SetParent(this);
	
	m_dlgPropSheet.Create(this, WS_CHILD | WS_VISIBLE, 0);
	m_dlgPropSheet.ModifyStyleEx (0, WS_EX_CONTROLPARENT);
	m_dlgPropSheet.ModifyStyle( 0, WS_TABSTOP );	
	
	CRect rcSheet;
	GetDlgItem( IDC_PROPSHEET )->GetWindowRect( &rcSheet );
	ScreenToClient( &rcSheet );
	m_dlgPropSheet.SetWindowPos( NULL, rcSheet.left-7, rcSheet.top-7, 0, 0, 
			SWP_NOZORDER | SWP_NOSIZE | SWP_NOACTIVATE );
	
	//m_dlgPropSheet.SetActivePage(4);
	m_dlgPropSheet.SetActivePage(3);
	m_dlgPropSheet.SetActivePage(2);
	m_dlgPropSheet.SetActivePage(1);
	m_dlgPropSheet.SetActivePage(0);

	// create events
	stopEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	resetEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	readEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	event1 = CreateEvent(NULL,TRUE,FALSE,NULL);
	event2 = CreateEvent(NULL,TRUE,FALSE,NULL);

	DWORD threadid;
	//start de thread
	thread=CreateThread(NULL,NULL,MyThread,(void*)this,0,&threadid);

	scbase = new CSCBase(resetEvent,readEvent);
	scbase2 = new CSCBase(NULL,NULL);
		
	if (strcmp(lastlist,"NULL")!=0)
	{
		if (!LoadList(lastlist))
		{
			NewList();
		}
	}
	else
	{
		NewList();
	}	
	
	m_pageCOM.m_logname.SetWindowText(logname);
	m_pageSCC.mode=mode;
	switch(mode)
	{
	case 0:
		m_pageSCC.m_radio1.SetCheck(1);			
		break;
	case 1:
		m_pageSCC.m_radio2.SetCheck(1);
		break;
	case 2:
		m_pageSCC.m_radio3.SetCheck(1);
		break;
	case 3:
		m_pageSCC.m_radio4.SetCheck(1);
		break;
	}
	dump_len=m_pageLog.GetDumpLen();
	u_reply[0]=0x90;
	u_reply[1]=0x00;
	init=FALSE;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy3MacsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting
	
	CRect rect,rect2;

	GetDlgItem(IDC_PROPSHEET)->GetWindowRect(rect);
	ScreenToClient(rect);
	
	rect2.top=rect.bottom+15;
	rect2.bottom=rect2.top+20;
	rect2.left=rect.left;
	rect2.right=rect2.left+200;
	dc.SetBkMode(TRANSPARENT);


	CFont * OldFont = dc.SelectObject(&m_fontLogo);

	// draw text in DC
	COLORREF OldColor = dc.SetTextColor( ::GetSysColor( COLOR_3DHILIGHT));

	dc.DrawText( m_LogoText, rect2+ CPoint(1,1), DT_SINGLELINE | DT_LEFT | DT_VCENTER);
	dc.SetTextColor( ::GetSysColor( COLOR_3DSHADOW));
	dc.DrawText( m_LogoText, rect2,DT_SINGLELINE | DT_LEFT | DT_VCENTER);
	

	// restore old text color
	dc.SetTextColor( OldColor);
	// restore old font
	dc.SelectObject(OldFont);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy3MacsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMy3MacsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		m_dlgPropSheet.SetActivePage(3);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
DWORD CMy3MacsDlg::MyThread(LPVOID p)
{
	CMy3MacsDlg*	dlg = (CMy3MacsDlg*)p;
	HANDLE		wevents[4] = {NULL,NULL,NULL,NULL};
	DWORD		bytes,wobject,bb,cnt,bb2,bytes2;
	BYTE		buf[256];
	BYTE		buf2[256];
	CCommand	*com,*com2;
	CCommand	temp;

	wevents[0]=dlg->stopEvent;
	wevents[1]=dlg->resetEvent;
	wevents[2]=dlg->readEvent;
	wevents[3]=dlg->event1;
	while (TRUE)
	{
		wobject=WaitForMultipleObjects(4,wevents,FALSE,INFINITE);
		if (wobject==WAIT_FAILED)
			wobject=wobject;
		switch (wobject)
		{
		case WAIT_OBJECT_0:		// stopEvent
			return 0;
			break;
		case WAIT_OBJECT_0+1:	// resetEvent
			switch (dlg->mode)
			{
			case 0:
				dlg->m_pageLog.m_log.AddString("RESET");
				dlg->m_pageLog.m_log.SetCaretIndex(dlg->m_pageLog.m_log.GetCount()-1,FALSE);
				WaitForSingleObject(wevents[0],250);
				ResetEvent(wevents[1]);
				break;
			case 1:
				dlg->scbase->Write(dlg->ATRMsg,dlg->ATRSize);
				dlg->m_pageLog.m_log.AddString("RESET");
				cnt=0;
				bytes=1;
				while (cnt<64 && bytes!=0)
				{
					bytes=dlg->scbase->Read(&buf[cnt],1,1);
					if (buf[cnt]==0x90)
						break;
					cnt++;
				}
				if (cnt>=64 || bytes==0)
						dlg->m_pageLog.m_log.AddString("Error sending ATR");
				bytes=dlg->scbase->Read(&buf[++cnt],1,1);
				if (buf[cnt]!=0x00)
						dlg->m_pageLog.m_log.AddString("Error sending ATR");
				dlg->Dump(buf,cnt+1);

				//dlg->scbase->SetConfig(dlg->serconfig);
				ResetEvent(wevents[1]);
				break;
			case 2:
				ResetEvent(wevents[1]);
				break;
			case 3:		//Phoenix
				dlg->scbase->Write(dlg->ATRMsg,dlg->ATRSize);
				dlg->m_pageLog.m_log.AddString("RESET");
				cnt=0;
				bytes=1;
				while (cnt<64 && bytes!=0)
				{
					bytes=dlg->scbase->Read(&buf[cnt],1,1);
					if (buf[cnt]==0x90)
						break;
					cnt++;
				}
				if (cnt>=64 || bytes==0)
						dlg->m_pageLog.m_log.AddString("Error sending ATR");
				bytes=dlg->scbase->Read(&buf[++cnt],1,1);
				if (buf[cnt]!=0x00)
						dlg->m_pageLog.m_log.AddString("Error sending ATR");
				dlg->Dump(buf,cnt+1);

				//dlg->scbase->SetConfig(dlg->serconfig);
				ResetEvent(wevents[1]);
				break;
			}
			break;
		case WAIT_OBJECT_0+2:	// readEvent
			switch (dlg->mode)
			{
			case 0:
				ResetEvent(wevents[2]);
				bytes=dlg->scbase->Read(buf,128);
				dlg->Dump(buf,bytes);
				break;
			case 1:
				ResetEvent(wevents[2]);
				bytes=dlg->scbase->Read(buf,5,2);
				if (bytes==0)
					break;
				if (bytes<5)
				{
					dlg->m_pageLog.m_log.AddString("Error on receive");
					dlg->m_pageLog.m_log.SetCaretIndex(dlg->m_pageLog.m_log.GetCount()-1,FALSE);
					break;
				}
				com=dlg->FindCommand(buf);
				if (com==NULL)
				{
					dlg->m_pageLog.m_log.AddString("Unknown command:");
					dlg->scbase->Write(dlg->u_reply,2);
					bytes+=dlg->scbase->Read(buf+bytes,2,4);
				}
				else
				{
					dlg->scbase->Write(&com->com[1],1);
					if (com->dir==1)
					{
						bb=dlg->scbase->Read(buf+bytes,com->com[4]+1,10);
						if (bb<com->com[4]+1)
							dlg->m_pageLog.m_log.AddString("Error on receive (length)");
						bytes+=bb;
					}
					else
					{
						dlg->scbase->Write(com->msg2,com->com[4]);	
						bb=dlg->scbase->Read(buf+bytes,com->com[4]+1,10);
						if (bb<com->com[4]+1)	
							dlg->m_pageLog.m_log.AddString("Error on receive (length2)");
						bytes+=bb;
					}
					dlg->scbase->Write(com->reply,2);
					bytes+=dlg->scbase->Read(buf+bytes,2,4);
				}
				dlg->Dump(buf,bytes);
				break;
			case 2:
				break;
			case 3:
				ResetEvent(wevents[2]);
				bytes=dlg->scbase->Read(buf,5,2);
				if (bytes==0)
					break;
				if (bytes!=5)
				{
					dlg->m_pageLog.m_log.AddString("Error on receive");
					dlg->m_pageLog.m_log.SetCaretIndex(dlg->m_pageLog.m_log.GetCount()-1,FALSE);
					break;
				}
				com=dlg->FindCommand(buf);
				if (com==NULL)
				{
					dlg->m_pageLog.m_log.AddString("Unknown/Blocked command:");
					dlg->scbase->Write(dlg->u_reply,2);
					bytes+=dlg->scbase->Read(buf+bytes,2,4);
					dlg->Dump(buf,bytes);
				}
				else
				{
					if (com->dir==1) // from decoder to smartcard
					{
						dlg->scbase->Write(&com->com[1],1);
						bb=dlg->scbase->Read(buf+bytes,com->com[4]+1,10);
						if (bb<com->com[4]+1)
							dlg->m_pageLog.m_log.AddString("Error on receive (length)");
						bytes+=bb;
						
						com2=dlg->DetermineWayOfHandling2(buf,&temp);
						if (com2==NULL)
						{
							dlg->m_pageLog.m_log.AddString("Blocked command:");
							dlg->scbase->Write(dlg->u_reply,2);
							bytes+=dlg->scbase->Read(buf+bytes,2,4);
							dlg->Dump(buf,bytes);
						}
						else
						{
							dlg->Dump(buf,bytes);
							bytes2=dlg->ExecuteCommand(&temp,buf2);
							dlg->Dump2(buf2,bytes2);
							dlg->scbase->Write(temp.reply,2);
							bytes=dlg->scbase->Read(buf,2,4);
							dlg->Dump(buf,bytes);
						}
					}
					else // from smartcard to decoder
					{
						dlg->Dump(buf,bytes);
						bytes2=dlg->ExecuteCommand(com,buf2);	// send to smartcard
						// determine way of handling
						dlg->DetermineWayOfHandling(buf2,buf,&bytes);
						if (bytes==0)
						{
							dlg->m_pageLog.m_log.AddString("Blocked command:");
							dlg->Dump2(buf2,bytes2);
							dlg->scbase->Write(dlg->u_reply,2);
							bytes=dlg->scbase->Read(buf,2,4);
							dlg->Dump(buf,bytes);		
						}
						else
						{
							dlg->Dump2(buf2,bytes2);
							dlg->scbase->Write(&com->com[1],1);	//send ACK
						
							dlg->scbase->Write(buf,bytes);	// send data
							bb=dlg->scbase->Read(buf,bytes+1,10);
							if (bb<bytes+1)
								dlg->m_pageLog.m_log.AddString("Error on receive (length2)");
							bytes=bb;
							dlg->Dump(buf,bytes);
						}
					}
				}
				break;
			}
			break;
		case WAIT_OBJECT_0+3:	// event1
			ResetEvent(wevents[3]);
			SetEvent(dlg->event2);
			WaitForSingleObject(wevents[3],INFINITE);
			ResetEvent(wevents[3]);
			break;
		}
	}
	return 0;
}
CCommand*	CMy3MacsDlg::FindCommand(BYTE *command)
{
	int			cnt,i;
	POSITION	pos;
	CCommand	*com;
	
	cnt=commands.GetCount();
	pos=commands.GetHeadPosition();
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		if (memcmp(command,com->com,5)==0)
			return com;
	}
	return NULL;
}

void CMy3MacsDlg::Dump(BYTE *buf,int bytes)
{
	char		string[256];
	char		string2[25];
	DWORD		i,j,cnt;

	if (buf==NULL)
		return;
	dump_len=m_pageLog.GetDumpLen();
	if (bin==1 && logfile!=NULL)
	{
		fwrite(&buf,1,bytes,logfile);
	}
	cnt=0;
	while (bytes>0)
	{
		if (bytes>=dump_len)
			j=dump_len;
		else
			j=bytes;
		bytes-=j;
		string[0]=0x00;
		for(i=0;i<j;i++)
		{
			sprintf(string2,"%02hX ",buf[cnt]);
			cnt++;
			strcat(string,string2);
		}
		m_pageLog.m_log.AddString(string);
		if (bin==0 && logfile!=NULL)
		{
			fprintf(logfile,"%s\n",string);
		}
	}
	m_pageLog.m_log.SetCaretIndex(m_pageLog.m_log.GetCount()-1,FALSE);
}
void CMy3MacsDlg::Dump2(BYTE *buf,int bytes)
{
	char		string[256];
	char		string2[25];
	DWORD		i,j,cnt;

	if (buf==NULL)
		return;
	dump_len=m_pageLog.GetDumpLen();
	if (bin==1 && logfile!=NULL)
	{
		fwrite(&buf,1,bytes,logfile);
	}
	cnt=0;
	while (bytes>0)
	{
		if (bytes>=dump_len)
			j=dump_len;
		else
			j=bytes;
		bytes-=j;
		strcpy(string,"[");
		for(i=0;i<j;i++)
		{
			sprintf(string2,"%02hX ",buf[cnt]);
			cnt++;
			strcat(string,string2);
		}
		strcat(string,"]");
		m_pageLog.m_log.AddString(string);
		if (bin==0 && logfile!=NULL)
		{
			fprintf(logfile,"%s\n",string);
		}
	}
	m_pageLog.m_log.SetCaretIndex(m_pageLog.m_log.GetCount()-1,FALSE);
}
int CMy3MacsDlg::LoadList(const char *fn)
{
	FILE*	fin;
	int		cnt,i,inv;
	CCommand	*com;
	char	string[256];

	fin=fopen(fn,"rb");
	if (fin==NULL)
		return 0;
	
	SetEvent(event1);
	WaitForSingleObject(event2,INFINITE);
	ResetEvent(event2);

	CleanupList();
	// first strings
	fread(lognameB,sizeof(lognameB),1,fin);
	fread(logname,sizeof(logname),1,fin);
	fread(serconfigB,sizeof(serconfigB),1,fin);
	fread(serconfig,sizeof(serconfig),1,fin);
	fread(serconfig2B,sizeof(serconfig2B),1,fin);
	fread(serconfig2,sizeof(serconfig2),1,fin);
	fread(&ATRSize,sizeof(DWORD),1,fin);
	fread(ATRMsg,64,1,fin);
	fseek(fin,256-sizeof(int),SEEK_CUR);//reserved!
	fread(&inv,sizeof(int),1,fin);
	fread(&bin,sizeof(int),1,fin);
	
	m_pageCOM.m_inv2.SetCheck(inv);
	fread(&inv,sizeof(int),1,fin);
	m_pageCOM.m_inv.SetCheck(inv);
	
	m_pageCOM.m_logname.SetWindowText(logname);
	m_pageCOM.m_serconfig.SetWindowText(serconfig);
	m_pageCOM.m_serconfig2.SetWindowText(serconfigB);

	fread(&cnt,sizeof(cnt),1,fin);
	for(i=0;i<cnt;i++)
	{
		com=new CCommand();
		fread(com,sizeof(CCommand),1,fin);
		commands.AddTail(com);
		sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",com->id,
				com->com[0],com->com[1],com->com[2],com->com[3],com->com[4]);
		m_pageSCC.m_commands.AddString(string);
		m_pageLog.m_commands.AddString(string);
	}
	fclose(fin);
	SetEvent(event1);
	return 1;
}
int CMy3MacsDlg::SaveList(const char *fn)
{
	FILE*	fin;
	int		cnt,i,inv;
	CCommand	*com;
	POSITION	pos;

	fin=fopen(fn,"w+b");
	if (fin==NULL)
	{	
		AfxMessageBox("Could not save",MB_OK);
		return 0;
	}

	fwrite(lognameB,sizeof(lognameB),1,fin);
	fwrite(logname,sizeof(logname),1,fin);
	fwrite(serconfigB,sizeof(serconfigB),1,fin);
	fwrite(serconfig,sizeof(serconfig),1,fin);
	fwrite(serconfig2B,sizeof(serconfig2B),1,fin);
	fwrite(serconfig2,sizeof(serconfig2),1,fin);
	fwrite(&ATRSize,sizeof(DWORD),1,fin);
	fwrite(ATRMsg,64,1,fin);
	fwrite(serconfig2B,sizeof(serconfig2B),1,fin);	//reserved
	fwrite(serconfig2B,sizeof(serconfig2B)-sizeof(int),1,fin);
	inv=m_pageCOM.m_inv2.GetCheck();
	fwrite(&inv,sizeof(int),1,fin);
	inv=m_pageCOM.m_bin.GetCheck();
	fwrite(&inv,sizeof(int),1,fin);
	inv=m_pageCOM.m_inv.GetCheck();
	fwrite(&inv,sizeof(int),1,fin);

	cnt=commands.GetCount();
	fwrite(&cnt,sizeof(int),1,fin);
	pos=commands.GetHeadPosition();
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		fwrite(com,sizeof(CCommand),1,fin);
	}
	fclose(fin);
	return 1;
}
int	CMy3MacsDlg::ExecuteCommand(CCommand *com,BYTE* buf)
{
	DWORD	bb,bytes_read;

	scbase2->Write(com->com,5);
	WaitForSingleObject(stopEvent,50);
	bytes_read=scbase2->Read(buf,6);
	if (bytes_read<5)
	{
		return bytes_read;
	}
	else if (bytes_read==5)
	{
		WaitForSingleObject(stopEvent,150);
		bytes_read+=scbase2->Read(buf+5,1);
		if (bytes_read==5)
		{
			return bytes_read;
		}
	}
	if (buf[5]!=com->com[1])
	{
		bytes_read+=scbase2->Read(buf+6,1);
		return bytes_read;
	}

	// command msg?
	if (com->dir==1)	// msg to smartcard
	{
		scbase2->Write(com->msg2,com->com[4]);
		bb=scbase2->Read(buf+bytes_read,com->com[4],6);
		bytes_read+=bb;
		if (bb!=com->com[4])
			return bytes_read;
	}
	else
	{
		bytes_read+=scbase2->Read(buf+bytes_read,com->com[4],6);
	}
	scbase2->Read(buf+bytes_read,2,6);
	bytes_read+=2;
	return bytes_read;
}
void CMy3MacsDlg::NewList()
{
	SetEvent(event1);
	WaitForSingleObject(event2,INFINITE);
	ResetEvent(event2);

	CleanupList();
	strcpy(logname,"test2.txt");
	strcpy(lognameB,"test.txt");
	strcpy(serconfig,"COM2: baud=10472 parity=E data=8 stop=2");
	strcpy(serconfig2,"COM2: baud=10472 parity=E data=8 stop=2");
	strcpy(serconfigB,"COM2: baud=9600 parity=E data=8 stop=2");
	strcpy(serconfig2B,"COM2: baud=9600 parity=E data=8 stop=2");
	m_pageCOM.m_inv.SetCheck(0);
	m_pageCOM.m_inv2.SetCheck(0);
	m_pageCOM.m_logname.SetWindowText(logname);
	m_pageCOM.m_serconfig.SetWindowText(serconfig);
	m_pageCOM.m_serconfig2.SetWindowText(serconfigB);
	strcpy(lastlist,"noname.scc");
	ATRSize=2;
	ATRMsg[0]=0x90;
	ATRMsg[1]=0x00;
	SetEvent(event1);
}
void CMy3MacsDlg::CleanupList()
{
	int			i,cnt;
	CCommand	*com;
	POSITION	pos;
	
	cnt=commands.GetCount();
	pos=commands.GetHeadPosition();
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		m_pageSCC.m_commands.DeleteString(1);
		m_pageLog.m_commands.DeleteString(0);
		delete com;
	}
	commands.RemoveAll();
}

/////////////////////////////////////////////////////////////////////////////
// CPageAbout property page

IMPLEMENT_DYNCREATE(CPageAbout, CPropertyPage)

CPageAbout::CPageAbout() : CPropertyPage(CPageAbout::IDD)
{
	//{{AFX_DATA_INIT(CPageAbout)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPageAbout::~CPageAbout()
{
}

void CPageAbout::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageAbout)
	DDX_Control(pDX, IDC_STATIC3, m_link3);
	DDX_Control(pDX, IDC_STATIC2, m_link2);
	DDX_Control(pDX, IDC_STATIC1, m_link1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageAbout, CPropertyPage)
	//{{AFX_MSG_MAP(CPageAbout)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageCode property page

IMPLEMENT_DYNCREATE(CPageCode, CPropertyPage)

CPageCode::CPageCode() : CPropertyPage(CPageCode::IDD)
{
	//{{AFX_DATA_INIT(CPageCode)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPageCode::~CPageCode()
{
}

void CPageCode::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageCode)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageCode, CPropertyPage)
	//{{AFX_MSG_MAP(CPageCode)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageCOM property page

IMPLEMENT_DYNCREATE(CPageCOM, CPropertyPage)

CPageCOM::CPageCOM() : CPropertyPage(CPageCOM::IDD)
{
	//{{AFX_DATA_INIT(CPageCOM)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPageCOM::~CPageCOM()
{
}

void CPageCOM::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageCOM)
	DDX_Control(pDX, IDC_EDIT3, m_serconfig2);
	DDX_Control(pDX, IDC_EDIT2, m_serconfig);
	DDX_Control(pDX, IDC_EDIT1, m_logname);
	DDX_Control(pDX, IDC_CHECK3, m_inv2);
	DDX_Control(pDX, IDC_CHECK2, m_inv);
	DDX_Control(pDX, IDC_CHECK1, m_bin);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageCOM, CPropertyPage)
	//{{AFX_MSG_MAP(CPageCOM)
	ON_BN_CLICKED(IDC_BUTTON1, OnBrowse)
	ON_EN_KILLFOCUS(IDC_EDIT2, OnKillfocusEdit2)
	ON_EN_KILLFOCUS(IDC_EDIT3, OnKillfocusEdit3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageLog property page

IMPLEMENT_DYNCREATE(CPageLog, CPropertyPage)

CPageLog::CPageLog() : CPropertyPage(CPageLog::IDD)
{
	//{{AFX_DATA_INIT(CPageLog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPageLog::~CPageLog()
{
}

void CPageLog::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageLog)
	DDX_Control(pDX, IDC_LIST2, m_commands);
	DDX_Control(pDX, IDC_LIST1, m_log);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageLog, CPropertyPage)
	//{{AFX_MSG_MAP(CPageLog)
	ON_LBN_DBLCLK(IDC_LIST2, OnDblclkList2)
	ON_MESSAGE(WM_SPLITTER_MOVED,OnSplitterMoved)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageSCC property page

IMPLEMENT_DYNCREATE(CPageSCC, CPropertyPage)

CPageSCC::CPageSCC() : CPropertyPage(CPageSCC::IDD)
{
	//{{AFX_DATA_INIT(CPageSCC)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPageSCC::~CPageSCC()
{
}

void CPageSCC::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageSCC)
	DDX_Control(pDX, IDC_LIST1, m_commands);
	DDX_Control(pDX, IDC_RADIO1, m_radio1);
	DDX_Control(pDX, IDC_RADIO2, m_radio2);
	DDX_Control(pDX, IDC_RADIO3, m_radio3);
	DDX_Control(pDX, IDC_RADIO4, m_radio4);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageSCC, CPropertyPage)
	//{{AFX_MSG_MAP(CPageSCC)
	ON_BN_CLICKED(IDC_BUTTON1, OnLoad)
	ON_BN_CLICKED(IDC_BUTTON2, OnSave)
	ON_BN_CLICKED(IDC_BUTTON3, OnNew)
	ON_BN_CLICKED(IDC_BUTTON4, OnSetATR)
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CMy3MacsDlg::OnReStart() 
{
	CString	string;
	BYTE	buf[256];
	DWORD	bytes;

	SetEvent(event1);
	WaitForSingleObject(event2,INFINITE);
	ResetEvent(event2);

	m_pageLog.m_log.ResetContent();
	m_pageLog.m_log.AddString("(Re)Starting...");
	
	if (logfile)
		fclose(logfile);
	bin=m_pageCOM.m_bin.GetCheck();
	if (bin==0)
		logfile=fopen(logname,"w+t");
	else
		logfile=fopen(logname,"w+b");

	scbase->Close();
	scbase2->Close();
	ResetEvent(readEvent);
	ResetEvent(resetEvent);
	mode=m_pageSCC.mode;
	switch(mode)
	{
	case 0:
		scbase->SetInvert(m_pageCOM.m_inv.GetCheck());
		scbase->Open(serconfig);
		scbase->SetConfig(serconfig);
		scbase->Flush();
		break;
	case 1:
		scbase->SetInvert(m_pageCOM.m_inv.GetCheck());
		scbase->Open(serconfig);
		scbase->SetConfig(serconfig);
		scbase->Flush();
		break;
	case 2:
		scbase2->SetInvert(m_pageCOM.m_inv2.GetCheck());
		scbase2->Open(serconfigB);
		scbase2->SetConfig(serconfigB);
		scbase2->Flush();
		scbase2->DoReset(serconfigB);
		bytes=scbase2->Read(buf,64,5);
		Dump(buf,bytes);
		break;
	case 3:
		scbase->SetInvert(m_pageCOM.m_inv.GetCheck());
		scbase->Open(serconfig);
		scbase->SetConfig(serconfig);
		scbase2->SetInvert(m_pageCOM.m_inv2.GetCheck());
		scbase2->Open(serconfigB);
		scbase2->SetConfig(serconfigB);
		scbase->Flush();
		scbase2->Flush();
		scbase2->DoReset(serconfigB);
		bytes=scbase2->Read(buf,64,5);
		Dump2(buf,bytes);
		break;
	}
	init=TRUE;
	
	SetEvent(event1);
}

void CMy3MacsDlg::OnDestroy() 
{
	HKEY	key;
	DWORD	stat;

	CDialog::OnDestroy();
	
	if (RegCreateKeyEx(HKEY_CLASSES_ROOT,"3Macs",NULL,"3Macs",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&key,&stat)==ERROR_SUCCESS)
	{         
		RegSetValueEx(key,"lastfile",NULL,REG_SZ,(unsigned char*)lastlist,strlen(lastlist)+1);
		RegSetValueEx(key,"lastmode",NULL,REG_DWORD,(unsigned char*)&mode,sizeof(mode));
	}
	RegCloseKey(key);
	

	SetEvent(stopEvent);
	WaitForSingleObject(thread,INFINITE);
	delete scbase;
	delete scbase2;
	CloseHandle(stopEvent);
	CloseHandle(resetEvent);
	CloseHandle(readEvent);
	CloseHandle(event1);
	CloseHandle(event2);
}

void CPageSCC::OnLoad() 
{
	CFileDialog	dlg(TRUE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"SmartCard Configuration files (*.scc) | *.scc|All Files (*.*)|*.*||");
	char	string[256];

	strcpy(string,parent->lastlist);
	dlg.m_ofn.lpstrFile=string;

	if (dlg.DoModal()==IDOK)
	{
		if (parent->LoadList(dlg.GetPathName()))
		{
			strcpy(parent->lastlist,dlg.GetPathName());
		}
	}
}

void CPageSCC::OnSave() 
{
	CFileDialog	dlg(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"SmartCard Configuration files (*.scc) | *.scc|All Files (*.*)|*.*||");
	char	string[256];

	strcpy(string,parent->lastlist);
	dlg.m_ofn.lpstrFile=string;
	dlg.m_ofn.lpstrDefExt="scc";
	if (dlg.DoModal()==IDOK)
	{
		if (parent->SaveList(dlg.GetPathName()))
		{
			strcpy(parent->lastlist,dlg.GetPathName());
		}
	}
}

void CPageSCC::OnNew() 
{
	parent->NewList();
}

void CPageSCC::OnSetATR() 
{
	BYTE		buf[sizeof(parent->ATRMsg)];
	CSetATR	dlg(this);

	memcpy(buf,parent->ATRMsg,sizeof(parent->ATRMsg));
	dlg.ATRMsg=buf;
	dlg.ATRSize=parent->ATRSize;
	if (dlg.DoModal()==IDOK)
	{
		memcpy(parent->ATRMsg,dlg.ATRMsg,sizeof(parent->ATRMsg));
		parent->ATRSize=dlg.ATRSize;
	}	
}
void CPageSCC::OnDblclkList1() 
{
	CEditInstruction	dlg(&parent->commands,this);	
	CEditInstructionTalkDlg	dlg2(this);	
	char		string[256];
	int			res,sel1,sel2;
	POSITION	pos;
	CCommand	com;
	
	if (m_radio1.GetCheck())
	{
		AfxMessageBox("Editing of instructions not allowed in \"Log Mode\"");
		return;
	}
	if (m_radio4.GetCheck())
	{
		if (m_commands.GetCurSel()<0)
			return;
		if (m_commands.GetCurSel()==0)
		{
			dlg.com = new CCommand();
		}
		else
		{
			pos=parent->commands.FindIndex(m_commands.GetCurSel()-1);
			com=(*(parent->commands.GetAt(pos)));
			dlg.com = &com;
		}
		if ((res=dlg.DoModal())==IDOK)
		{
			SetEvent(parent->event1);
			WaitForSingleObject(parent->event2,INFINITE);
			ResetEvent(parent->event2);
			if (m_commands.GetCurSel()==0)
			{
				parent->commands.AddTail(dlg.com);
				sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",dlg.com->id,
					dlg.com->com[0],dlg.com->com[1],dlg.com->com[2],dlg.com->com[3],dlg.com->com[4]);
				m_commands.AddString(string);
				// insert in log page!
				parent->m_pageLog.m_commands.AddString(string);
			}
			else
			{
				pos=parent->commands.FindIndex(m_commands.GetCurSel()-1);
				(*(parent->commands.GetAt(pos)))=com;

				sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",dlg.com->id,
					dlg.com->com[0],dlg.com->com[1],dlg.com->com[2],dlg.com->com[3],dlg.com->com[4]);
				m_commands.InsertString(sel1=m_commands.GetCurSel(),string);
				m_commands.DeleteString(sel2=m_commands.GetCurSel());
				m_commands.SetCaretIndex(sel2-1,FALSE);
				// insert in log page!
				parent->m_pageLog.m_commands.InsertString(sel1-1,string);
				parent->m_pageLog.m_commands.DeleteString(sel2-1);
				parent->m_pageLog.m_commands.SetCaretIndex(sel2-2,FALSE);
			}
			SetEvent(parent->event1);
		}
		else if (res==IDABORT)
		{
			SetEvent(parent->event1);
			WaitForSingleObject(parent->event2,INFINITE);
			ResetEvent(parent->event2);

			if (m_commands.GetCurSel()>0)
			{
				pos=parent->commands.FindIndex(m_commands.GetCurSel()-1);
				parent->commands.RemoveAt(pos);
				m_commands.DeleteString(sel2=m_commands.GetCurSel());
				m_commands.SetCurSel(0);
				parent->m_pageLog.m_commands.DeleteString(sel2-1);
				parent->m_pageLog.m_commands.SetCurSel(0);
			}
			SetEvent(parent->event1);
		}	
	} else if (m_radio2.GetCheck() || m_radio3.GetCheck())
	{
		if (m_commands.GetCurSel()<0)
			return;
		if (m_commands.GetCurSel()==0)
		{
			dlg2.com = new CCommand();
		}
		else
		{
			pos=parent->commands.FindIndex(m_commands.GetCurSel()-1);
			com=(*(parent->commands.GetAt(pos)));
			dlg2.com = &com;
		}
		if ((res=dlg2.DoModal())==IDOK)
		{
			SetEvent(parent->event1);
			WaitForSingleObject(parent->event2,INFINITE);
			ResetEvent(parent->event2);
			if (m_commands.GetCurSel()==0)
			{
				parent->commands.AddTail(dlg2.com);
				sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",dlg2.com->id,
					dlg2.com->com[0],dlg2.com->com[1],dlg2.com->com[2],dlg2.com->com[3],dlg2.com->com[4]);
				m_commands.AddString(string);
				// insert in log page!
				parent->m_pageLog.m_commands.AddString(string);
			}
			else
			{
				pos=parent->commands.FindIndex(m_commands.GetCurSel()-1);
				(*(parent->commands.GetAt(pos)))=com;

				sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",dlg2.com->id,
					dlg2.com->com[0],dlg2.com->com[1],dlg2.com->com[2],dlg2.com->com[3],dlg2.com->com[4]);
				m_commands.InsertString(sel1=m_commands.GetCurSel(),string);
				m_commands.DeleteString(sel2=m_commands.GetCurSel());
				m_commands.SetCaretIndex(sel2-1,FALSE);
				// insert in log page!
				parent->m_pageLog.m_commands.InsertString(sel1-1,string);
				parent->m_pageLog.m_commands.DeleteString(sel2-1);
				parent->m_pageLog.m_commands.SetCaretIndex(sel2-2,FALSE);
			}
			SetEvent(parent->event1);
		}
		else if (res==IDABORT)
		{
			SetEvent(parent->event1);
			WaitForSingleObject(parent->event2,INFINITE);
			ResetEvent(parent->event2);

			if (m_commands.GetCurSel()>0)
			{
				pos=parent->commands.FindIndex(m_commands.GetCurSel()-1);
				parent->commands.RemoveAt(pos);
				m_commands.DeleteString(sel2=m_commands.GetCurSel());
				m_commands.SetCurSel(0);
				parent->m_pageLog.m_commands.DeleteString(sel2-1);
				parent->m_pageLog.m_commands.SetCurSel(0);
			}
			SetEvent(parent->event1);
		}	
	}
}

BOOL CPageSCC::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_commands.InsertString(0,"New instruction");
	m_commands.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPageCOM::OnBrowse() 
{
	CFileDialog	*dlg;
	char	string[256];

	if (m_bin.GetCheck()==1)
	{
		dlg= new CFileDialog(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"log files (*.bin) | *.bin|All Files (*.*)|*.*||");
		dlg->m_ofn.lpstrDefExt="bin";
	}
	else
	{
		dlg= new CFileDialog(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"log files (*.txt) | *.txt|All Files (*.*)|*.*||");
		dlg->m_ofn.lpstrDefExt="txt";
	}
	
	strcpy(string,parent->logname);
	dlg->m_ofn.lpstrFile=string;
	
	if (dlg->DoModal()==IDOK)
	{
		strcpy(parent->logname,dlg->GetPathName());
		m_logname.SetWindowText(parent->logname);
		parent->m_pageLog.m_log.AddString("Click Re(Start) for new settings to take effect!");
		parent->m_pageLog.m_log.SetCaretIndex(parent->m_pageLog.m_log.GetCount()-1,FALSE);
	}
	delete dlg;
}

BOOL CPageLog::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CRect rect(0,0,0,0);
	m_wndVSplitterBar.Create(WS_CHILD|WS_BORDER|WS_DLGFRAME|WS_VISIBLE,rect,this,998);
	m_wndVSplitterBar.SetPanes(&m_commands,&m_log);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPageAbout::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_link1.SetURL("http://eurosat.com/macdouf/");

	m_fontLogo.CreateFont(48, 0, 0, 0, FW_BOLD, TRUE, FALSE,0,0,0,0,0,0,"Arial");
	m_LogoText="Macdouf's Research";

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CPageSCC::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	mode=0;	
}

void CPageSCC::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	mode=1;
}

void CPageSCC::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	mode=2;
}

void CPageLog::OnDblclkList2() 
{
	DWORD		res;
	POSITION	pos;
	BYTE		buf[256];

	if (!parent->init || !(parent->mode==2))
		return;
	if (m_commands.GetCurSel()==LB_ERR)
		return;
	pos=parent->commands.FindIndex(m_commands.GetCurSel());
	if ((res=parent->ExecuteCommand(parent->commands.GetAt(pos),buf))==0)
	{
		m_log.AddString("Command execution failed!");
		m_log.SetCaretIndex(m_log.GetCount()-1,FALSE);
	}
		
	parent->Dump(buf,res);
	
	m_log.SetCaretIndex(m_log.GetCount()-1,FALSE);
}

LRESULT CPageLog::OnSplitterMoved(WPARAM,LPARAM)
{
	parent->dump_len=GetDumpLen();

	return 0L;
}
int	CPageLog::GetDumpLen()
{
	CRect	rect;
	int		res;
	m_log.GetWindowRect(rect);
	res=(rect.right-rect.left)/18;
	if (res<=0)
		return 1;
	else
		return res;
}

void CPageCOM::OnKillfocusEdit2() 
{
	m_serconfig.GetWindowText(parent->serconfig,128);	
}

void CPageCOM::OnKillfocusEdit3() 
{
	// TODO: Add your control notification handler code here
	m_serconfig2.GetWindowText(parent->serconfigB,128);	
}

void CPageSCC::OnRadio4() 
{
	// TODO: Add your control notification handler code here
	mode=3;
}
void CMy3MacsDlg::DetermineWayOfHandling(BYTE *buf2,BYTE *buf,DWORD	*bytes)
{
	int			cnt,i;
	POSITION	pos;
	CCommand	*com,*com_flag,*com_good;
	
	cnt=commands.GetCount();
	pos=commands.GetHeadPosition();
	com_flag=NULL;
	com_good=NULL;
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		if (memcmp(buf2,com->com,5)==0)
		{
			if (com->compare)
			{
				if (memcmp(buf2+6,com->msg,com->com[4])==0)	//exact key match
				{
					if (com->route)	//take from smartcard
					{
						memcpy(buf,buf2+6,com->com[4]+2);
						*bytes=2+com->com[4];
					}
					else	// take from database
					{
						memcpy(buf,com->msg2,com->com[4]);
						memcpy(buf+com->com[4],com->reply,2);
						*bytes=2+com->com[4];
					}
					return;
				}
			}
			else if (com->flag)
				com_flag=com;
			else
				com_good=com;
		}
	}
	if (com_flag)
	{
		com_flag->flag=0;
		if (com_flag->route)	//take from smartcard
		{
			memcpy(buf,buf2+6,com_flag->com[4]+2);
			*bytes=2+com_flag->com[4];
		}
		else	// take from database
		{
			memcpy(buf,com_flag->msg2,com_flag->com[4]);
			memcpy(buf+com_flag->com[4],com_flag->reply,2);
			*bytes=2+com_flag->com[4];
		}
		return;
	}
	if (com_good)
	{
		if (com_good->route)	//take from smartcard
		{
			memcpy(buf,buf2+6,com_good->com[4]+2);
			*bytes=2+com_good->com[4];
		}
		else	// take from database
		{
			memcpy(buf,com_good->msg2,com_good->com[4]);
			memcpy(buf+com_good->com[4],com_good->reply,2);
			*bytes=2+com_good->com[4];
		}
		return;
	}
	*bytes=0;
	return;
}
CCommand* CMy3MacsDlg::DetermineWayOfHandling2(BYTE *buf2,CCommand* com2)
{
	int			cnt,i;
	POSITION	pos;
	CCommand	*com,*com_good;
	
	cnt=commands.GetCount();
	pos=commands.GetHeadPosition();
	com_good=NULL;
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		if (memcmp(buf2,com->com,5)==0)
		{
			if (com->compare)
			{
				if (memcmp(buf2+6,com->msg,com->com[4])==0)	//exact key match
				{
					if (com->link>0)
					{
						pos=commands.FindIndex(com->link-1);
						com_good=commands.GetAt(pos);
						com_good->flag=1;
					}
					memcpy(com2,com,sizeof(CCommand));
					if (com->route)
						memcpy(com2->msg2,buf2+6,com->com[4]);
					return com;
				}
			} 
			else 
				com_good=com;
		}
	}
	if (com_good)
	{
		if (com_good->link>0)
		{
			pos=commands.FindIndex(com_good->link-1);
			com=commands.GetAt(pos);
			com->flag=1;
		}
		memcpy(com2,com_good,sizeof(CCommand));
		if (com_good->route)
			memcpy(com2->msg2,buf2+6,com_good->com[4]);
		return com_good;
	}
	return NULL;
}

void CPageAbout::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CRect rect2;
		
	rect2.top=25;
	rect2.bottom=rect2.top+40;
	rect2.left=10;
	rect2.right=rect2.left+420;
	dc.SetBkMode(TRANSPARENT);


	CFont * OldFont = dc.SelectObject(&m_fontLogo);

	// draw text in DC
	COLORREF OldColor = dc.SetTextColor( ::GetSysColor( COLOR_3DFACE));

	dc.DrawText( m_LogoText, rect2+ CPoint(1,1), DT_SINGLELINE | DT_LEFT | DT_VCENTER);
	dc.SetTextColor( ::GetSysColor( COLOR_3DSHADOW));
	dc.DrawText( m_LogoText, rect2,DT_SINGLELINE | DT_LEFT | DT_VCENTER);
	

	// restore old text color
	dc.SetTextColor( OldColor);
	// restore old font
	dc.SelectObject(OldFont);

	// Do not call CPropertyPage::OnPaint() for painting messages
}
/////////////////////////////////////////////////////////////////////////////
// CPageHelp property page

IMPLEMENT_DYNCREATE(CPageHelp, CPropertyPage)

CPageHelp::CPageHelp() : CPropertyPage(CPageHelp::IDD)
{
	//{{AFX_DATA_INIT(CPageHelp)
	//}}AFX_DATA_INIT
}

CPageHelp::~CPageHelp()
{
}

void CPageHelp::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageHelp)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageHelp, CPropertyPage)
	//{{AFX_MSG_MAP(CPageHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageHelp message handlers

BOOL CPageHelp::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	//m_web.SetMenuBar(TRUE);
	//m_web.Navigate("d:\\frontpage webs\\content\\3macshelp\\macdoufs_research.htm",NULL,NULL,NULL,NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
