// 3MacsDlg.h : header file
//
//{{AFX_INCLUDES()
//#include "webbrowser2.h"
//}}AFX_INCLUDES

#if !defined(AFX_3MACSDLG_H__7DE81F96_3B1A_11D2_8FA4_002048402D5A__INCLUDED_)
#define AFX_3MACSDLG_H__7DE81F96_3B1A_11D2_8FA4_002048402D5A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "scbase.h"
#include "editinstruction.h"
#include "editinstructiontalkdlg.h"
#include "mystructs.h"
#include "setatr.h"
#include "splitterbar.h"
#include "hyperlink.h"

class CMy3MacsDlg;

/////////////////////////////////////////////////////////////////////////////
// CPageHelp dialog

class CPageHelp : public CPropertyPage
{
	DECLARE_DYNCREATE(CPageHelp)

// Construction
public:
	CPageHelp();
	~CPageHelp();

// Dialog Data
	//{{AFX_DATA(CPageHelp)
	enum { IDD = IDD_DIALOG8 };
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPageHelp)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPageHelp)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CPageAbout dialog

class CPageAbout : public CPropertyPage
{
	DECLARE_DYNCREATE(CPageAbout)

// Construction
public:
	CPageAbout();
	~CPageAbout();
	void SetParent(CMy3MacsDlg* p)
	{
		parent=p;
	}
	CMy3MacsDlg	*parent;
	CFont	m_fontLogo;
	CString	m_LogoText;

// Dialog Data
	//{{AFX_DATA(CPageAbout)
	enum { IDD = IDD_DIALOG2 };
	CHyperLink	m_link3;
	CHyperLink	m_link2;
	CHyperLink	m_link1;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPageAbout)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPageAbout)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CPageCode dialog

class CPageCode : public CPropertyPage
{
	DECLARE_DYNCREATE(CPageCode)

// Construction
public:
	CPageCode();
	~CPageCode();
	void SetParent(CMy3MacsDlg* p)
	{
		parent=p;
	}
	CMy3MacsDlg	*parent;

// Dialog Data
	//{{AFX_DATA(CPageCode)
	enum { IDD = IDD_DIALOG5 };
		// NOTE - ClassWizard will add data members here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPageCode)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPageCode)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CPageCOM dialog

class CPageCOM : public CPropertyPage
{
	DECLARE_DYNCREATE(CPageCOM)

// Construction
public:
	CPageCOM();
	~CPageCOM();
	void SetParent(CMy3MacsDlg* p)
	{
		parent=p;
	}
	CMy3MacsDlg	*parent;
// Dialog Data
	//{{AFX_DATA(CPageCOM)
	enum { IDD = IDD_DIALOG4 };
	CEdit	m_serconfig2;
	CEdit	m_serconfig;
	CEdit	m_logname;
	CButton	m_inv2;
	CButton	m_inv;
	CButton	m_bin;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPageCOM)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPageCOM)
	afx_msg void OnBrowse();
	afx_msg void OnKillfocusEdit2();
	afx_msg void OnKillfocusEdit3();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
/////////////////////////////////////////////////////////////////////////////
// CPageLog dialog

class CPageLog : public CPropertyPage
{
	DECLARE_DYNCREATE(CPageLog)

// Construction
public:
	CPageLog();
	~CPageLog();
	void SetParent(CMy3MacsDlg* p)
	{
		parent=p;
	}
	CMy3MacsDlg	*parent;
	CSplitterBar m_wndVSplitterBar;
	LRESULT OnSplitterMoved(WPARAM,LPARAM);
	int	GetDumpLen();

// Dialog Data
	//{{AFX_DATA(CPageLog)
	enum { IDD = IDD_DIALOG1 };
	CListBox	m_commands;
	CListBox	m_log;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPageLog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPageLog)
	virtual BOOL OnInitDialog();
	afx_msg void OnDblclkList2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
/////////////////////////////////////////////////////////////////////////////
// CPageSCC dialog

class CPageSCC : public CPropertyPage
{
	DECLARE_DYNCREATE(CPageSCC)

// Construction
public:
	CPageSCC();
	~CPageSCC();
	void SetParent(CMy3MacsDlg* p)
	{
		parent=p;
	}
	CMy3MacsDlg	*parent;
	int			mode;
// Dialog Data
	//{{AFX_DATA(CPageSCC)
	enum { IDD = IDD_DIALOG3 };
	CListBox	m_commands;
	CButton		m_radio1;
	CButton		m_radio2;
	CButton		m_radio3;
	CButton		m_radio4;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPageSCC)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPageSCC)
	afx_msg void OnLoad();
	afx_msg void OnSave();
	afx_msg void OnNew();
	afx_msg void OnSetATR();
	afx_msg void OnDblclkList1();
	virtual BOOL OnInitDialog();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	afx_msg void OnRadio3();
	afx_msg void OnRadio4();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
/////////////////////////////////////////////////////////////////////////////
// CMy3MacsDlg dialog

class CMy3MacsDlg : public CDialog
{
// Construction
public:
	CMy3MacsDlg(CWnd* pParent = NULL);	// standard constructor
	
	static DWORD WINAPI MyThread(LPVOID param);

	void OnSysCommand(UINT nID, LPARAM lParam);
	CFont	m_fontLogo;
	CString	m_LogoText;
	CPropertySheet		m_dlgPropSheet;
	CPageLog			m_pageLog;
	CPageCOM			m_pageCOM;
	CPageSCC			m_pageSCC;
	CPageAbout			m_pageAbout;
	CPageCode			m_pageCode;
	CPageHelp			m_pageHelp;
	
	int	mode,bin;

	int LoadList(const char*);
	int SaveList(const char*);
	int	ExecuteCommand(CCommand *com,BYTE*);
	void NewList();
	void Dump(BYTE*,int);
	void Dump2(BYTE*,int);
	void CleanupList();
	void DetermineWayOfHandling(BYTE*,BYTE*,DWORD*);
	CCommand*   DetermineWayOfHandling2(BYTE*,CCommand*);
	CCommand*	FindCommand(BYTE *command);

	HANDLE		thread,stopEvent,resetEvent,readEvent,event1,event2;
	FILE*		logfile;
	BYTE		buf[256];
	BYTE		reply[2];
	CSCBase*	scbase;
	CSCBase*	scbase2;
	//DWORD		bytes_read;
	char	serconfig2[128],serconfig[128],logname[128],lastlist[256];
	char	serconfig2B[128],serconfigB[128],lognameB[128];
	BYTE	ATRMsg[64];
	BYTE	u_reply[2];
	DWORD	ATRSize;
	int		dump_len;
	BOOL	init;
	
	CTypedPtrList<CPtrList,CCommand*>	commands;
	

// Dialog Data
	//{{AFX_DATA(CMy3MacsDlg)
	enum { IDD = IDD_MY3MACS_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMy3MacsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMy3MacsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnReStart();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_3MACSDLG_H__7DE81F96_3B1A_11D2_8FA4_002048402D5A__INCLUDED_)
