// EditInstructionTalkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "3Macs.h"
#include "EditInstructionTalkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditInstructionTalkDlg dialog


CEditInstructionTalkDlg::CEditInstructionTalkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditInstructionTalkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditInstructionTalkDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CEditInstructionTalkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditInstructionTalkDlg)
	DDX_Control(pDX, IDC_EDIT4, m_msg);
	DDX_Control(pDX, IDC_EDIT3, m_reply);
	DDX_Control(pDX, IDC_EDIT2, m_comment);
	DDX_Control(pDX, IDC_EDIT1, m_header);
	DDX_Control(pDX, IDC_RADIO1, m_check1);
	DDX_Control(pDX, IDC_RADIO2, m_check2);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditInstructionTalkDlg, CDialog)
	//{{AFX_MSG_MAP(CEditInstructionTalkDlg)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDABORT, OnAbort)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditInstructionTalkDlg message handlers

void CEditInstructionTalkDlg::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	com->dir=1;		
}

void CEditInstructionTalkDlg::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	com->dir=0;	
}

BOOL CEditInstructionTalkDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	char	string[300];
	char	string2[20];
	DWORD	cnt,i,j,b;
	CCommand *com2;
	POSITION	pos;

	CDialog::OnInitDialog();
	
	sprintf(string,"%02hX %02hX %02hX %02hX %02hX",com->com[0],com->com[1],com->com[2],com->com[3],com->com[4]);
	m_header.SetWindowText(string);
	sprintf(string,"%02hX %02hX",com->reply[0],com->reply[1]);
	m_reply.SetWindowText(string);
	if (com->dir==1)
		m_check1.SetCheck(1);
	else if (com->dir==0)
		m_check2.SetCheck(1);
	
	m_comment.SetWindowText(com->id);

	cnt=0;
	b=com->com[4];
	string[0]=0x00;
	while (b>0)
	{
		if (b>=8)
			j=8;
		else
			j=b;
		b-=j;
		for(i=0;i<j;i++)
		{
			sprintf(string2,"%02hX ",com->msg2[cnt]);
			cnt++;
			strcat(string,string2);
		}
		strcat(string,"\r\n");
	}
	m_msg.SetWindowText(string);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CEditInstructionTalkDlg::OnOK( )
{
	CString	string;
	char	string2[256];
	int		i;
	DWORD	a,b,c,d,e;

	m_header.GetWindowText(string);
	sscanf(string,"%hX %hX %hX %hX %hX",&a,&b,&c,&d,&e);
	com->com[0]=(BYTE)a;
	com->com[1]=(BYTE)b;
	com->com[2]=(BYTE)c;
	com->com[3]=(BYTE)d;
	com->com[4]=(BYTE)e;


	m_comment.GetWindowText(com->id,64);

	m_reply.GetWindowText(string);
	sscanf(string,"%hX %hX",&a,&b);
	com->reply[0]=(BYTE)a;
	com->reply[1]=(BYTE)b;

	m_msg.GetWindowText(string);
	if (com->com[4]>0 && !string.IsEmpty())
	{
		string.MakeUpper();
		string.TrimLeft();
		string.TrimRight();
		i=0;
		while (i<com->com[4] && !string.IsEmpty())
		{
			sscanf(string,"%02hX",&a);
			com->msg2[i]=(BYTE)a;
			string=(const char*)string +2;
			string.TrimLeft();
			i++;
		}
		if (string.IsEmpty() && i<com->com[4])
		{
			sprintf(string2,"Not enough instruction message bytes (%02hX < %02hX)!",i,com->com[4]);
			AfxMessageBox(string2,MB_OK);
			return;
		}
		if (!string.IsEmpty() && i==com->com[4])
		{
			sprintf(string2,"Too many instruction message bytes!");
			AfxMessageBox(string2,MB_OK);
			return;
		}
	}
	CDialog::OnOK();
}
void CEditInstructionTalkDlg::OnAbort() 
{
	EndDialog(IDABORT);
}