#if !defined(__SCBASE__)
#define __SCBASE__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSCBase {
public:
	CSCBase(HANDLE,HANDLE);
	~CSCBase();
	DWORD Read(BYTE*,DWORD,DWORD all=0);
	DWORD Write(BYTE*,DWORD);
	
	void SetConfig(const char*);
	void Close();
	void Open(const char*);
	void SetInvert(int);
	void WaitFor();
	void Flush();
	void DoReset(const char *);
protected:
	BYTE adapt(BYTE);
	static DWORD WINAPI LocalThread(LPVOID param);
	virtual void HandleReset();
	virtual void HandleRead();

	HANDLE	stopEvent,hCom,thread,readyEvent,stopCommEvent,commEvent;
	HANDLE	resetEvent,readEvent,event1,event2;
	OVERLAPPED	overl,overl2,overl3;
	
	DWORD	dwEvtMask;

	int		invert,tweak;
	BYTE	loc_buf[256];
};

#endif
